VERSION 5.00
Begin VB.Form TVSample19 
   Caption         =   "Dynamic LOD Bezier Patch :)"
   ClientHeight    =   5610
   ClientLeft      =   3435
   ClientTop       =   2325
   ClientWidth     =   6990
   LinkTopic       =   "Form1"
   ScaleHeight     =   5610
   ScaleWidth      =   6990
End
Attribute VB_Name = "TVSample19"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-----------------------------------------------------------------
' TrueVision 3D  Sample 19 : Bezier Patchs for usual objects
'----------------------------------------------------------------
 
'
' CUBIC BEZIER PATCH : See Form_Load ;)
'
 
Public TV As New TrueVision8
Public Scene As New Scene8
Public Scr As New Screen8
Public Inp As New InputEngine8

Public CubicPatch As Mesh8


Private Sub Form_Load()
  'Init the engine
  TV.EnableHardwareTL True
  TV.Init3DWindowedMode TVSample19.hWnd
  
  TV.DisplayFPS = True
  TVSample19.Show
  
  
  
  '------------------------------------------
  ' There is two sorts of Patches :
  ' Quadratic and Cubic
  '------------------------------------------
  
  'First : Cubic :
  'Cubic Patch is controlled by 16 control points
  '( 4 x 4 )
  
  'Second : Quadratic
  'Quadratic Patch is controlled by 9 control points
  
  'This is a example :
  
  Scene.LoadTexture App.Path + "\down.jpg", , , "CubicTex"
  
  Dim Cp(16) As D3DVECTOR
  
  Cp(0) = Vector3(-10, 0, -10)
  Cp(1) = Vector3(-5, 20, -10)
  Cp(2) = Vector3(0, 0, -10)
  Cp(3) = Vector3(5, 0, -10)
  
  Cp(4) = Vector3(-10, 0, -5)
  Cp(5) = Vector3(-5, 0, -5)
  Cp(6) = Vector3(0, -20, -5)
  Cp(7) = Vector3(5, 0, -5)
  
  Cp(8) = Vector3(-10, 0, 0)
  Cp(9) = Vector3(-5, 0, 0)
  Cp(10) = Vector3(0, 0, 0)
  Cp(11) = Vector3(5, 0, 0)
  
  Cp(12) = Vector3(-10, 0, 5)
  Cp(13) = Vector3(-5, 0, 5)
  Cp(14) = Vector3(0, 0, 5)
  Cp(15) = Vector3(5, 0, 5)
  
  
  'Create the Cubic Patch
  Set CubicPatch = Scene.CreateMeshBuilder("Cubic")
  
  'Let's use a LOD = 4.
  CubicPatch.AddCubicBezierPatch Cp(), 4, GetTex("CubicTex")
  
  
  Scene.SetCamera 0, 0, -20, 0, 0, 0
  
  
  Do
    TV.Clear
    
   
   'Rotate the camera and the object
   Scene.SetCamera Cos(a) * 20, 0, Sin(a) * 20, 0, 0, 0
   a = a + TV.TimeElapsed * 0.0006
   
   CubicPatch.Render
   CubicPatch.RotateX 0.001 * TV.TimeElapsed
    
    'Draw some infos
    Scene.DrawText CStr(Scene.GetTriangleNumber * TV.GetFPS) & " tri/sec" & Chr(13) & Chr(13) & "1 Solid mode" & Chr(13) & "2 WireFrame mode" & Chr(13) & "3 Dynamic mode", 10, 45, RGBA(1, 1, 0, 1)
    
    If Anim = True Then
      ' When you want a dynamic patch, you just have to
      ' change some control points and use
      ' Set[Cubic/Quadratic]BezierPatch()
      
      Cp(10).y = Cos(a * 8) * 20
      Cp(14).y = Sin(a * 8) * 20
      Cp(6).y = Cos(a * 8) * 20
      Cp(2).y = Sin(a * 8) * 20
      Cp(9).y = Cos(a * 8) * 20
      Cp(13).y = Sin(a * 8) * 20
      Cp(5).y = Cos(a * 8) * 20
      Cp(1).y = Sin(a * 8) * 20
      
      
      CubicPatch.SetCubicBezierPatch Cp()
      
    End If
       
      
    
    If Inp.IsKeyPressed(TV_KEY_1) Or Inp.IsKeyPressed(TV_KEY_NUMPAD1) Then
      Scene.SetRenderMode TV_SOLID
    End If
    If Inp.IsKeyPressed(TV_KEY_2) Or Inp.IsKeyPressed(TV_KEY_NUMPAD2) Then
      Scene.SetRenderMode TV_LINE
    End If
    If Inp.IsKeyPressed(TV_KEY_3) Or Inp.IsKeyPressed(TV_KEY_NUMPAD3) Then
      Anim = Not Anim
    End If
    
    
    
    TV.RenderToScreen
   
  Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True
  
  Set TV = Nothing
  End
End Sub


